// ShapeTest.cpp
// Modified from Deitel, 4th ed. by MGR - 071102
// Fig. 10.2: fig10_02.cpp
// Driver for shape, point, circle, cylinder hierarchy
#include <iostream>
#include <iomanip>
#include "Shape.h"
#include "Point1.h"
#include "Circle1.h"
#include "Cylindr1.h"

int main()
{
   Point point( 7, 11 );                  // create a Point
   Circle circle( 3.5, 22, 8 );           // create a Circle
   Cylinder cylinder( 10, 3.3, 10, 10 );  // create a Cylinder

   Shape *arrayOfShapes[ 3 ]; // array of base-class pointers

   cout << setiosflags( ios::fixed | ios::showpoint )
        << setprecision( 2 ); // set output formatting

   point.printShapeName();    // static binding
   point.print();             // static binding
   cout << '\n';

   circle.printShapeName();   // static binding
   circle.print();            // static binding
   cout << '\n';

   cylinder.printShapeName(); // static binding
   cylinder.print();          // static binding
   cout << "\n\n";

   // aim arrayOfShapes[i] at derived-class objects
   arrayOfShapes[ 0 ] = &point;
   arrayOfShapes[ 1 ] = &circle;
   arrayOfShapes[ 2 ] = &cylinder;

   // Loop through arrayOfShapes and print the shape name, attributes, 
   // area, and volume of each object using dynamic binding.
   cout << "Virtual function calls made off base-class pointers\n";
   for ( int i = 0; i < 3; i++ ) 
   {  
      arrayOfShapes[i]->printShapeName();
      arrayOfShapes[i]->print();
      cout << "\nArea = " << arrayOfShapes[i]->area()
           << "\nVolume = " << arrayOfShapes[i]->volume() << "\n\n";
   }
   return 0;
}

/* Output

Point: [7, 11]
Circle: [22, 8]; Radius = 3.50
Cylinder: [10, 10]; Radius = 3.30; Height = 10.00

Virtual function calls made off base-class pointers
Point: [7, 11]
Area = 0.00
Volume = 0.00

Circle: [22, 8]; Radius = 3.50
Area = 38.48
Volume = 0.00

Cylinder: [10, 10]; Radius = 3.30; Height = 10.00
Area = 275.77
Volume = 342.12

*/
/* Shape class hierarchy

   ---------------------
   |      Shape        | : Abstract
   ---------------------
            |
	    v
   ---------------------
   |      Point        | : Concrete
   ---------------------
            |
	    v
   ---------------------
   |      Circle       | : Concrete
   ---------------------
            |
	    v
   ---------------------
   |     Cylinder      | : Concrete
   ---------------------
 
*/
